// ޸View.cpp : CMyView Ŭ 
//

#include "stdafx.h"
#include "޸.h"

#include "޸Doc.h"
#include "޸View.h"
#include ".\޸view.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMyView

IMPLEMENT_DYNCREATE(CMyView, CFormView)

BEGIN_MESSAGE_MAP(CMyView, CFormView)
	ON_COMMAND(ID_TextProperty, OnTextproperty)
	ON_COMMAND(ID_BOLD, OnBold)
	ON_COMMAND(ID_ITALIC, OnItalic)
	ON_COMMAND(ID_STRIKEOUT, OnStrikeout)
	ON_COMMAND(ID_UNDERLINE, OnUnderline)
	ON_COMMAND(ID_TEXTCOLOR, OnTextcolor)
	ON_COMMAND(ID_BgTextColor, OnBgtextcolor)
	ON_COMMAND(ID_PARA_LEFT, OnParaLeft)
	ON_COMMAND(ID_PARA_RIGHT, OnParaRight)
	ON_COMMAND(ID_PARA_CENTER, OnParaCenter)
	ON_WM_SIZE()
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_COMMAND(ID_TEXT_DEFAULT, OnTextDefault)
END_MESSAGE_MAP()

// CMyView /Ҹ

CMyView::CMyView()
	: CFormView(CMyView::IDD)
	, CF_Format_LiNs(0)
{
	// TODO: ⿡  ڵ带 ߰մϴ.
}

CMyView::~CMyView()
{
}

void CMyView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
}

BOOL CMyView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: CREATESTRUCT cs Ͽ ⿡
	// Window Ŭ Ǵ Ÿ մϴ.

	return CFormView::PreCreateWindow(cs);
}

void CMyView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();
	//--------------------------------------------------
	//  ؼ   
	CF_Format_LiNs = RegisterClipboardFormat("LiNs");
	if(CF_Format_LiNs == 0)
		MessageBox("ο Ŭ Ͽ ߳׿","̷",MB_OK);
	//--------------------------------------------------
	// ġƮ ʱⰪ 
	//  Ӽ 
	CHARFORMAT2 cf;
	CRichEditCtrl* hRichEdit;
	memset(&cf,0,sizeof(CHARFORMAT2));
	cf.cbSize = sizeof(CHARFORMAT2);
	cf.dwMask=CFM_COLOR | CFM_FACE | CFM_SIZE | CFM_BOLD | CFM_ITALIC | CFM_UNDERLINE | CFM_STRIKEOUT | CFM_BACKCOLOR;
	cf.crTextColor=RGB(0,0,0);
	cf.crBackColor=RGB(255,255,255);
	cf.yHeight=10*20;
	strcpy(cf.szFaceName, "ü");
	cf.dwEffects=0;

	hRichEdit = (CRichEditCtrl*)GetDlgItem(IDC_RICHEDIT21);	//ڵ鰪 
	hRichEdit->SetSelectionCharFormat(cf);					//Ѵ.
	//  Ӽ 
	pf.cbSize = sizeof(PARAFORMAT2);
	pf.dwMask = PFM_ALIGNMENT;
	pf.wAlignment = PFA_LEFT;

	// ó Ǹ ťƮ  ѹ   ȿ ش
	m_pDocument->OnNewDocument();

	
}


// CMyView 

#ifdef _DEBUG
void CMyView::AssertValid() const
{
	CFormView::AssertValid();
}

void CMyView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CMyDoc* CMyView::GetDocument() const // ׵   ζ ˴ϴ.
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMyDoc)));
	return (CMyDoc*)m_pDocument;
}
#endif //_DEBUG


// CMyView ޽ ó

void CMyView::OnTextproperty()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CRichEditCtrl *hRichEdit = (CRichEditCtrl*)GetDlgItem(IDC_RICHEDIT21);	//ڵ鰪 
	
	hRichEdit->GetSel(cr);					// õ κ ġ ϰ

	hRichEdit->SetSel(cr.cpMin,cr.cpMin+1);	//ù° ڸ õǰ ϰ
	hRichEdit->GetSelectionCharFormat(cf);	//õ κ ù ð о´
	
	CFontDialog cFont(cf);				//ƮŬ ü ϳ ϰ
	if( (IDOK == cFont.DoModal()))		//̾α ڸ 
		cFont.GetCharFormat(cf);		//Ӱ  Ʈ CF  ְ

	hRichEdit->SetSel(cr);					//ο  Է  ϰ(Ʊ  Ѱ)
	hRichEdit->SetSelectionCharFormat(cf);	//Ѵ.

}

void CMyView::OnBold()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CRichEditCtrl *hRichEdit = (CRichEditCtrl*)GetDlgItem(IDC_RICHEDIT21);	//ڵ鰪 
	
	hRichEdit->GetSel(cr);					// õ κ ġ ϰ

	hRichEdit->SetSel(cr.cpMin,cr.cpMin+1);	//ù° ڸ õǰ ϰ
	hRichEdit->GetSelectionCharFormat(cf);	//õ κ ù ð о´

	if((cf.dwEffects & CFE_BOLD)) cf.dwEffects &= (~CFE_BOLD); else cf.dwEffects |= CFE_BOLD;
	
	hRichEdit->SetSel(cr);					//ο  Է  ϰ(Ʊ  Ѱ)
	hRichEdit->SetSelectionCharFormat(cf);	//Ѵ.
}

void CMyView::OnItalic()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CRichEditCtrl *hRichEdit = (CRichEditCtrl*)GetDlgItem(IDC_RICHEDIT21);	//ڵ鰪 
	
	hRichEdit->GetSel(cr);					// õ κ ġ ϰ

	hRichEdit->SetSel(cr.cpMin,cr.cpMin+1);	//ù° ڸ õǰ ϰ
	hRichEdit->GetSelectionCharFormat(cf);	//õ κ ù ð о´

	if((cf.dwEffects & CFE_ITALIC)) cf.dwEffects &= (~CFE_ITALIC); else cf.dwEffects |= CFE_ITALIC;

	
	hRichEdit->SetSel(cr);					//ο  Է  ϰ(Ʊ  Ѱ)
	hRichEdit->SetSelectionCharFormat(cf);	//Ѵ.
}

void CMyView::OnStrikeout()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CRichEditCtrl *hRichEdit = (CRichEditCtrl*)GetDlgItem(IDC_RICHEDIT21);	//ڵ鰪 
	
	hRichEdit->GetSel(cr);					// õ κ ġ ϰ

	hRichEdit->SetSel(cr.cpMin,cr.cpMin+1);	//ù° ڸ õǰ ϰ
	hRichEdit->GetSelectionCharFormat(cf);	//õ κ ù ð о´

	if((cf.dwEffects & CFE_STRIKEOUT)) cf.dwEffects &= (~CFE_STRIKEOUT); else cf.dwEffects |= CFE_STRIKEOUT;

	
	hRichEdit->SetSel(cr);					//ο  Է  ϰ(Ʊ  Ѱ)
	hRichEdit->SetSelectionCharFormat(cf);	//Ѵ.
}

void CMyView::OnUnderline()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CRichEditCtrl *hRichEdit = (CRichEditCtrl*)GetDlgItem(IDC_RICHEDIT21);	//ڵ鰪 
	
	hRichEdit->GetSel(cr);					// õ κ ġ ϰ

	hRichEdit->SetSel(cr.cpMin,cr.cpMin+1);	//ù° ڸ õǰ ϰ
	hRichEdit->GetSelectionCharFormat(cf);	//õ κ ù ð о´

	if((cf.dwEffects & CFE_UNDERLINE)) cf.dwEffects &= (~CFE_UNDERLINE); else cf.dwEffects |= CFE_UNDERLINE;
	
	hRichEdit->SetSel(cr);					//ο  Է  ϰ(Ʊ  Ѱ)
	hRichEdit->SetSelectionCharFormat(cf);	//Ѵ.
}

void CMyView::OnTextcolor()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CRichEditCtrl *hRichEdit = (CRichEditCtrl*)GetDlgItem(IDC_RICHEDIT21);	//ڵ鰪 
	CColorDialog cColorDlg;
	
	hRichEdit->GetSel(cr);					// õ κ ġ ϰ

	hRichEdit->SetSel(cr.cpMin,cr.cpMin+1);	//ù° ڸ õǰ ϰ
	hRichEdit->GetSelectionCharFormat(cf);	//õ κ ù ð о´

	hRichEdit->SetSel(cr);					// κ Ѵ


	if(	IDOK==cColorDlg.DoModal())
		cf.crTextColor = cColorDlg.GetColor();
	hRichEdit->SetSelectionCharFormat(cf);	//Ѵ.

}
void CMyView::OnBgtextcolor()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CRichEditCtrl *hRichEdit = (CRichEditCtrl*)GetDlgItem(IDC_RICHEDIT21);	//ڵ鰪 
	CColorDialog cColorDlg;
	
	hRichEdit->GetSel(cr);					// õ κ ġ ϰ

	hRichEdit->SetSel(cr.cpMin,cr.cpMin+1);	//ù° ڸ õǰ ϰ
	hRichEdit->GetSelectionCharFormat(cf);	//õ κ ù ð о´

	hRichEdit->SetSel(cr);					// κ Ѵ


	if(	IDOK==cColorDlg.DoModal())
		cf.crBackColor = cColorDlg.GetColor();
	hRichEdit->SetSelectionCharFormat(cf);	//Ѵ.
}

void CMyView::OnParaLeft()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CRichEditCtrl *hRichEdit = (CRichEditCtrl*)GetDlgItem(IDC_RICHEDIT21);	//ڵ鰪 
	hRichEdit->GetSel(cr);					// õ κ ġ ϰ
	pf.wAlignment = PFA_LEFT;
	hRichEdit->SetSel(cr);					// κ Ѵ
	hRichEdit->SetParaFormat(pf);
}


void CMyView::OnParaRight()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CRichEditCtrl *hRichEdit = (CRichEditCtrl*)GetDlgItem(IDC_RICHEDIT21);	//ڵ鰪 
	hRichEdit->GetSel(cr);					// õ κ ġ ϰ
	pf.wAlignment = PFA_RIGHT;
	hRichEdit->SetSel(cr);					// κ Ѵ
	hRichEdit->SetParaFormat(pf);

}

void CMyView::OnParaCenter()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CRichEditCtrl *hRichEdit = (CRichEditCtrl*)GetDlgItem(IDC_RICHEDIT21);	//ڵ鰪 
	hRichEdit->GetSel(cr);					// õ κ ġ ϰ
	pf.wAlignment = PFA_CENTER;
	hRichEdit->SetSel(cr);					// κ Ѵ
	hRichEdit->SetParaFormat(pf);
}
//------------------------------------------------------------------------------------------
//   ġƮƮѵ   ִ κ
void CMyView::OnSize(UINT nType, int cx, int cy)
{
	CFormView::OnSize(nType, cx, cy);
	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
	CRichEditCtrl *hRichEdit = (CRichEditCtrl*)GetDlgItem(IDC_RICHEDIT21);	//ڵ鰪 
	if(hRichEdit != NULL)	//ó ɶ ġ Ʈ  ȵǾ ֱ 
        hRichEdit->MoveWindow(0,0,cx,cy,true);
}
//------------------------------------------------------------------------------------------
//Ŭ ֱ Լ
void CMyView::OnEditPaste()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CRichEditCtrl *hRichEdit = (CRichEditCtrl*)GetDlgItem(IDC_RICHEDIT21);	//ڵ鰪 
	CString *ptr = new CString;
	HGLOBAL hmem;		
	CHARFORMAT2 *TmpCF= new CHARFORMAT2;			//õ κ Ӽ  
	hRichEdit->GetSel(cr);							// õ κ ġ ϰ
	bool CheckCF = false;							//Ӽ  üũ
	
	if(IsClipboardFormatAvailable(CF_TEXT))			//Ŭ忡 TEXT ִ Ȯ
	{
		OpenClipboard();							//Ŭ带 
		hmem = GetClipboardData(CF_TEXT);			//ؽƮ оɴ
		ptr = (CString*)GlobalLock(hmem);			//ٸ APP  ϰ ɰ PTR Ѵ
		
		GlobalUnlock(hmem);							//ٸAPP   ְ  ϰ
		CloseClipboard();							//Ŭ带 ݴ´
	}

	if(IsClipboardFormatAvailable(CF_Format_LiNs))	//Ŭ忡 ؽƮ Ӽ ִ Ȯ
	{
		CheckCF = true;
		OpenClipboard();							//Ŭ带 
		hmem = GetClipboardData(CF_Format_LiNs);	//CF оɴ
		TmpCF = (CHARFORMAT2*)GlobalLock(hmem);			//ٸ APP  ϰ ɰ PTR Ѵ
		
		GlobalUnlock(hmem);							//ٸAPP   ְ  ϰ
		CloseClipboard();							//Ŭ带 ݴ´
	}

	hRichEdit->SetSel(cr);							//ο  Է  ϰ(Ʊ  Ѱ)
	if(CheckCF)
        hRichEdit->SetSelectionCharFormat(*TmpCF);	//Ѵ.
	hRichEdit->ReplaceSel((LPCTSTR)ptr,TRUE);		// Ŀ Ű κ ptr  óѴ.
	
}
//------------------------------------------------------------------------------------------
//Ŭ ϱ Լ
void CMyView::OnEditCopy()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CRichEditCtrl *hRichEdit = (CRichEditCtrl*)GetDlgItem(IDC_RICHEDIT21);	//ڵ鰪 
	HGLOBAL hMem,hMem2;		
	CString str;
	char *ptr;
	CHARFORMAT2 *ptr2;
	CHARFORMAT2 TmpCF;							//õ κ Ӽ  

	hRichEdit->GetSel(cr);						// õ κ ġ ϰ
	hRichEdit->SetSel(cr.cpMin,cr.cpMin+1);		//ù° ڸ õǰ ϰ
	hRichEdit->GetSelectionCharFormat(TmpCF);	//õ κ ù ð о´

	hRichEdit->SetSel(cr);						// κ Ѵ
	
	str = hRichEdit->GetSelText();				//õ κ ؽƮ о Ѵ

	int TextLength = str.GetLength();

	hMem = GlobalAlloc(GHND, TextLength+1);		//ؽƮ +1 ŭ ޸ Ҵ
	hMem2 = GlobalAlloc(GHND, sizeof(CHARFORMAT2)+1);	//(CHARFORMAT2)+1 ŭ ޸ Ҵ

	ptr = (char*)GlobalLock(hMem);				//  ޸͸ ǳ
	memcpy(ptr,str,TextLength);					//ؽƮ Ѵ.
	GlobalUnlock(hMem);

	ptr2 = (CHARFORMAT2*)GlobalLock(hMem2);			//  ޸͸ ǳ
	memcpy(ptr2,&TmpCF,sizeof(CHARFORMAT2));		// Ӽ Ѵ.
	GlobalUnlock(hMem2);

	if(OpenClipboard())
	{
		EmptyClipboard();						//Ŭ带 
		SetClipboardData(CF_TEXT,hMem);			//  ־ְ
		SetClipboardData(CF_Format_LiNs,hMem2);	// Ӽ ־ش
		CloseClipboard();
	}
}
//------------------------------------------------------------------------------------------
//߶󳻱 Լ
void CMyView::OnEditCut()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CRichEditCtrl *hRichEdit = (CRichEditCtrl*)GetDlgItem(IDC_RICHEDIT21);	//ڵ鰪 
	HGLOBAL hMem,hMem2;		
	CString str;
	char *ptr;
	CHARFORMAT2 *ptr2;
	CHARFORMAT2 TmpCF;							//õ κ Ӽ  

	hRichEdit->GetSel(cr);						// õ κ ġ ϰ
	hRichEdit->SetSel(cr.cpMin,cr.cpMin+1);		//ù° ڸ õǰ ϰ
	hRichEdit->GetSelectionCharFormat(TmpCF);	//õ κ ù ð о´

	hRichEdit->SetSel(cr);						// κ Ѵ
	
	str = hRichEdit->GetSelText();				//õ κ ؽƮ о Ѵ
	hRichEdit->Cut();							//õ κ ġƮ 
		
	int TextLength = str.GetLength();

	hMem = GlobalAlloc(GHND, TextLength+1);		//ؽƮ +1 ŭ ޸ Ҵ
	hMem2 = GlobalAlloc(GHND, sizeof(CHARFORMAT2)+1);	//(CHARFORMAT2)+1 ŭ ޸ Ҵ

	ptr = (char*)GlobalLock(hMem);				//  ޸͸ ǳ
	memcpy(ptr,str,TextLength);					//ؽƮ Ѵ.
	GlobalUnlock(hMem);

	ptr2 = (CHARFORMAT2*)GlobalLock(hMem2);		//  ޸͸ ǳ
	memcpy(ptr2,&TmpCF,sizeof(CHARFORMAT2));	// Ӽ Ѵ.
	GlobalUnlock(hMem2);

	if(OpenClipboard())
	{
		EmptyClipboard();						//Ŭ带 
		SetClipboardData(CF_TEXT,hMem);			//  ־ְ
		SetClipboardData(CF_Format_LiNs,hMem2);	// Ӽ ־ش
		CloseClipboard();
	}
}
//------------------------------------------------------------------------------------------
//ؽƮ  ϴ Լ
BOOL CMyView::ChangeTextSize(int iTextSize)
{
	CRichEditCtrl *hRichEdit = (CRichEditCtrl*)GetDlgItem(IDC_RICHEDIT21);	//ڵ鰪 
	CColorDialog cColorDlg;
	
	hRichEdit->GetSel(cr);					// õ κ ġ ϰ

	hRichEdit->SetSel(cr.cpMin,cr.cpMin+1);	//ù° ڸ õǰ ϰ
	hRichEdit->GetSelectionCharFormat(cf);	//õ κ ù ð о´

	hRichEdit->SetSel(cr);					// κ Ѵ

	cf.yHeight = iTextSize * 20;
	hRichEdit->SetSelectionCharFormat(cf);	//Ѵ.
	return 0;
}
//------------------------------------------------------------------------------------------
// Ҹ ϴ κ
void CMyView::OnEditUndo()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CRichEditCtrl *hRichEdit = (CRichEditCtrl*)GetDlgItem(IDC_RICHEDIT21);	//ڵ鰪 
	hRichEdit->Undo();
}
//------------------------------------------------------------------------------------------
// Ӽ ʱȭ մϴ
void CMyView::OnTextDefault()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CRichEditCtrl *hRichEdit = (CRichEditCtrl*)GetDlgItem(IDC_RICHEDIT21);	//ڵ鰪 
	hRichEdit->GetDefaultCharFormat(cf);
	hRichEdit->SetSelectionCharFormat(cf);
}
